-- **************************************************************************
--   TitanPals.lua
--
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanPals", true );

-- **************************************************************************
-- NAME : TitanPals_Init()
-- DESC : For first time addon use
-- **************************************************************************
function TitanPals_Init()
     if ( not TitanPals or TitanPals == nil ) then TitanPals = {}; end
     if ( not TitanPals["Init"] ) then
	  if ( not TitanPals["presets"] or TitanPals["presets"] == nil ) then
               TitanPals["presets"] = {
                    { name = "Style #1", value = "!s (!l !c) !p ~ !n !z", },
                    { name = "Style #2", value = "!s (!l) !uc ~ !n !z", },
                    { name = "Style #3", value = "!s (!l) !p - !c !z ~ !n", },
                    { name = "Style #4", value = "!s (!l) !c - !p !z ~ !n", },
                    { name = "Style #5", value = "!s (!l) !uc !z ~ !n", },
                    { name = "Style #6", value = "!s !p (!l) - !c !n ~ !z", },
                    { name = "Style #7", value = "!s !z (!l) - !c !n ~ !p", },
                    { name = "Style #8", value = "!s !c (!l) !z !n ~ !p", },
               };
          end
	  if ( not TitanPals["sTypes"] or TitanPals["sTypes"] == nil ) then
               TitanPals["sTypes"] = {
                    { name = "<Away>", value = "<Away>" },
                    { name = "<AFK>", value = "<AFK>" },
                    { name = "<A>", value = "<A>" },
                    { name = "(Away)", value = "(Away)" },
                    { name = "(AFK)", value = "(AFK)" },
                    { name = "(A)", value = "(A)" },
                    { name = "[Away]", value = "[Away]" },
                    { name = "[AFK]", value = "[AFK]" },
                    { name = "[A]", value = "[A]" },
               };
          end
          if ( not TitanPals["dType"] or TitanPals["dType"] == nil ) then
               TitanPals["dType"] = {
                    { name = "<DND>", value = "<DND>", },
                    { name = "<Busy>", value = "<Busy>", },
               };
          end
	  if ( not TitanPals["realidformats"] or TitanPals["realidformats"] == nil ) then
               TitanPals["realidformats"] = {
                    { name = "Format #1", value = "!cn" },
                    { name = "Format #2", value = "!cn - !rn" },
                    { name = "Format #3", value = "!sn/!cn" },
                    { name = "Format #4", value = "!ln/!cn" },
                    { name = "Format #5", value = "!fn/!cn" },
                    { name = "Format #6", value = "!fn/!cn - !rn" },
                    { name = "Format #7", value = "!fn ( !cn )" },
                    { name = "Format #8", value = "!cn ( !fn )" },
               };
          end
          if ( not TitanPals["RealIDs"] or TitanPals["RealIDs"] == nil ) then TitanPals["RealIDs"] = {}; end
          if ( not TitanPals["Debug"] or TitanPals["Debug"] == nil ) then
               TitanPals["Debug"] = {
                    State = false,
                    Event = false,
                    LogEvent = false,
                    dLine = "",
               };
          end
          if ( not TitanPals["Settings"] or TitanPals["Settings"] == nil ) then
               TitanPals["Settings"] = {
                    ShowIgnored = false,
                    ShowMem = true,
	            ShowBNTooltip = true,
                    UpDateDB = true,
                    DisplayB = true,
                    ShowMem = true,
                    NoAlts = true,
                    TFormat = "!s (!l !c) !p ~ !n !z",
                    SFormat = "<Away>",
                    DFormat = "<DND>",
                    dDefault = "Away",
                    RealIDFormat = "!cn",
               }
          end
	  if ( not TitanPals["DBVer"] or TitanPals["DBVer"] == nil ) then TitanPals["DBVer"] = ""; end
          if ( not TitanPals["Lists"] or TitanPals["Lists"] == nil ) then TitanPals["Lists"] = {}; end
          if ( not TitanPals["Alts"] or TitanPals["Alts"] == nil ) then TitanPals["Alts"] = {}; end
          if ( not TitanPals["Temp"] or TitanPals["Temp"] == nil ) then TitanPals["Temp"] = {}; end
	  if ( not TitanPals["AddVer"] or TitanPals["AddVer"] == nil ) then TitanPals["AddVer"] = LB["TITAN_PALS_CORE_ADDVER"]; end
          TitanPals["Init"] = true;
     end
     if ( not TitanPals["Profile"] or TitanPals["Profile"] == nil ) then
          TitanPals["Profile"] = {};
     end
     TitanPals["Profile"] = {
          Player = "UnKnown",
          Faction = "UnKnown",
          Realm = "UnKnown",
          Level = "UnKnown",
          Class = "UnKnown",
     };
     TitanPals["authors"] = nil;
     TitanPals["Master"] = nil;
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnEvent()
-- DESC : Event Handler
-- **************************************************************************
function TitanPanelPalsButton_OnEvent( self, event, ... )
     if ( TitanPals.Debug.Event ) then TitanPals_DebugUtils( "bug", "OnEvent", ( "[%s]" ):format ( TitanPals_ColorUtils( "GetCText", "gray", event ) ) ); end
     if ( event == "ADDON_LOADED" and arg1 == "TitanPals" ) then
          if ( not BNFeaturesEnabled() ) then TitanPals.Settings.ShowBNTooltip = false; end
     elseif ( event == "PLAYER_ENTERING_WORLD" ) then
          if ( TitanPals.Settings["DisplayB"] ) then TitanPals_CoreUtils( "DisplayB" ); end
          TitanPanelPals_SetUser();
     elseif ( event == "BN_FRIEND_ACCOUNT_ONLINE" or event == "BN_FRIEND_ACCOUNT_OFFLINE" or event == "FRIENDLIST_UPDATE" or event == "IGNORELIST_UPDATE" )then
          TitanPanelButton_UpdateButton( LB["TITAN_PALS_CORE_ID"] );
          TitanPanelButton_UpdateTooltip();
     end
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_GetButtonText()
-- DESC : Build Button Text
-- **************************************************************************
function TitanPanelPalsButton_GetButtonText()
     local NumIgnore = GetNumIgnores();
     local NumPals, NumPalsOnline = GetNumFriends();
     local _, BNetCount = BNGetNumFriends();
     local buttonRichText
     buttonRichText = TitanPals_ColorUtils( "GetCText", "green", NumPalsOnline );
     if ( TitanPals.Settings.ShowBNTooltip ) then
          buttonRichText = ( "%s/%s" ):format( buttonRichText, TitanPals_ColorUtils( "GetCText", "blue", BNetCount ) );
     end
     if ( TitanPals.Settings.ShowIgnored ) then 
          buttonRichText = ( "%s/%s" ):format( buttonRichText, TitanPals_ColorUtils( "GetCText", "red", NumIgnore ) );
     end
     return LB["TITAN_PALS_BUTTON_LABEL"], buttonRichText;
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnClick()
-- DESC : Toggles Friends Dialog
-- **************************************************************************
function TitanPanelPalsButton_OnClick( self, button )
     if ( button == "LeftButton" ) then
          ToggleFriendsFrame( 1 );
     else
          TitanPanelButton_OnClick( self, button );
     end
end

-- **************************************************************************
-- NAME : TitanPanelPals_SetUser()
-- DESC : Sets up the User for use with the data array
-- **************************************************************************
function TitanPanelPals_SetUser()
     local Fac = UnitFactionGroup( "player" );
     local Rea = GetCVar( "realmName" );
     local Pla = GetUnitName( "player" );
     local Lev = UnitLevel( "player" );
     local Cla = UnitClass( "player" );
     if ( not TitanPals.Profile["Player"] or TitanPals.Profile["Player"] ~= Pla ) then TitanPals.Profile["Player"] = Pla; end
     if ( not TitanPals.Profile["Faction"] or TitanPals.Profile["Faction"] ~= Fac ) then TitanPals.Profile["Faction"] = Fac; end
     if ( not TitanPals.Profile["Level"] or TitanPals.Profile["Level"] ~= Lev ) then TitanPals.Profile["Level"] = Lev; end
     if ( not TitanPals.Profile["Class"] or TitanPals.Profile["Class"] ~= Cla ) then TitanPals.Profile["Class"] = Cla; end
     if ( not TitanPals.Profile["Realm"] or TitanPals.Profile["Realm"]~= Rea ) then TitanPals.Profile["Realm"] = Rea; end
     if ( not palsDB or palsDB ~= ( "%s:%s" ):format( Fac, Rea ) ) then palsDB = ( "%s:%s" ):format( Fac, Rea ); end
     if ( not palsAuthor or palsAuthor ~= ( "%s@%s" ):format( Pla, Rea ) ) then palsAuthor = ( "%s@%s" ):format( Pla, Rea ); end
     if ( not TitanPals.Lists[palsDB] ) then TitanPals.Lists[palsDB] = {}; end
     if ( not TitanPals.Lists[palsDB][Pla] ) then TitanPals.Lists[palsDB][Pla] = {}; end
     if ( TitanPals.Lists[palsDB][Pla] ) then
          TitanPals.Lists[palsDB][Pla]["Class"] = Cla;
          TitanPals.Lists[palsDB][Pla]["Level"] = Lev;
          TitanPals.Lists[palsDB][Pla]["Note"] = "na";
     end
     if ( not TitanPals.Alts[palsDB] ) then TitanPals.Alts[palsDB] = {}; end
     if ( not TitanPals.Alts[palsDB][Pla] ) then TitanPals["Alts"][palsDB][Pla] = Cla; end
end

-- **************************************************************************
-- NAME : TitanPanelPals_SyncAlts()
-- DESC : This adds your alts to your friends list for things like mailing
-- **************************************************************************
function TitanPanelPals_SyncAlts()
     -- Alts to Pals List Syncing
     local np = GetNumFriends();
     local aIndex = TitanPals.Alts[palsDB];
     local fI, palsn, palsl, palsc, palsa, palsco, palss, palsno;
     for n, v in pairs( aIndex ) do
          local tp = 0;
          local fI;
          for fI=1, np do
               palsn = GetFriendInfo( fI );
               if ( n == palsn ) then tp = 1; end
          end
          if ( tp == 0 and n ~= TitanPals.Profile["Player"] ) then
               TitanPals_DebugUtils( "info", "SyncAlts", ( "Adding Alt %s to firends list" ):format( n ) );
               AddFriend( n ); 
          end
     end
     TitanPals_DebugUtils( "info", "Sybc Alts", "Sync Finished." );
end

-- **************************************************************************
-- NAME : TitanPanelPals_SyncAlts()
-- DESC : This syncs your alts friend to your friends list
-- **************************************************************************

function TitanPanelPals_SyncAltsFriends()
     local np = GetNumFriends();
     local iTable = TitanPals.Lists[palsDB];
     local palsn, palsl, palsc, palsa, palsco, palss, palsno;
     for n, v in pairs( iTable ) do
          if ( n ~= TitanPals.Profile["Player"] ) then
               --local v2, v3 = string.match(n, '(.*):(.*)');
               local tp = 0;
               local fI;
               for fI=1, np do
                    palsn = GetFriendInfo( fI );
                    if ( n == palsn ) then tp = 1; end
               end
               if ( tp == 0 and n ~= TitanPals.Profile["Player"] ) then
                    TitanPals_DebugUtils( "info", "SyncAltsFriends", ( "Adding %s to friends list" ):format( n ) );
                    AddFriend( n );
               end
	  end
     end
     TitanPals_DebugUtils( "info", "Sybc Alts", "Sync Finished." );
end